## vtk9 9.0.1+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8...3.12 FATAL_ERROR)
foreach(policy
    CMP0083 # CMake 3.14
    CMP0071 # CMake 3.10
    CMP0068 # CMake 3.9
    )
  if(POLICY ${policy})
    cmake_policy(SET ${policy} NEW)
  endif()
endforeach()

if (POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif ()
if (POLICY CMP0065)
  cmake_policy(SET CMP0065 NEW)
endif ()

project(VTK)

set(vtk_cmake_dir "${VTK_SOURCE_DIR}/CMake")
list(INSERT CMAKE_MODULE_PATH 0 "${vtk_cmake_dir}")

if (APPLE)
  include(vtkApple)
endif ()

# must be before the following iOS / Android
include(vtkVersion)
set(VTK_VERSION
    "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}.${VTK_BUILD_VERSION}")

option(VTK_IOS_BUILD "Build vtk.framework for iOS" OFF)
mark_as_advanced(VTK_IOS_BUILD)
if (VTK_IOS_BUILD)
  include(vtkiOS)
  return()
endif()

option(VTK_ANDROID_BUILD "Build VTK for Android" OFF)
mark_as_advanced(VTK_ANDROID_BUILD)
if (VTK_ANDROID_BUILD)
  include(vtkAndroid)
  return()
endif()

include(vtkCMakeBackports)

if (VTK_WHEEL_BUILD)
  include(vtkWheelPreparation)
endif ()

include(vtkCompilerChecks)
include(vtkCompilerPlatformFlags)
include(vtkCompilerExtraFlags)
include(vtkInitializeBuildType)
include(vtkSupportMacros)
include(vtkDownload)
include(vtkTesting)
include(vtkDirectories)
include(vtkMobileDevices)
include(vtkWrapSettings)
include(vtkCrossCompiling)
include(vtkObjectFactory)

set(CMAKE_INSTALL_LICENSEDIR ""
  CACHE PATH "License files (DATAROOTDIR/licenses/${CMAKE_PROJECT_NAME}")
mark_as_advanced(CMAKE_INSTALL_LICENSEDIR)
if (NOT CMAKE_INSTALL_LICENSEDIR)
  set(CMAKE_INSTALL_LICENSEDIR
    "${CMAKE_INSTALL_DATAROOTDIR}/licenses/${CMAKE_PROJECT_NAME}")
endif ()

# Setup compiler flags for dynamic analysis
# Should be included after vtkTesting
include(vtkCompilerDynamicAnalysisFlags)

set(VTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)

#-----------------------------------------------------------------------------
# Add the Remote Subdirectory
add_subdirectory(Remote)

#-----------------------------------------------------------------------------
# Does VTK require support for 64 bit file systems
include(CheckCXXSourceRuns)
file(READ "${vtk_cmake_dir}/vtkRequireLargeFilesSupport.cxx"
  VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE)
check_cxx_source_runs("${VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE}"
  CMAKE_REQUIRE_LARGE_FILE_SUPPORT "Support for 64 bit file systems")
set(VTK_REQUIRE_LARGE_FILE_SUPPORT ${CMAKE_REQUIRE_LARGE_FILE_SUPPORT})

#-----------------------------------------------------------------------------
# Provide compatibility options.
option(VTK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
option(VTK_LEGACY_SILENT "Silence all legacy code messages." OFF)
mark_as_advanced(VTK_LEGACY_REMOVE VTK_LEGACY_SILENT)

# Tell VTK source files they are being built inside VTK.
add_definitions(-DVTK_IN_VTK)

include(CheckTypeSize)

option(VTK_USE_MPI "Support MPI" OFF)

set(VTK_BUILD_TESTING "OFF"
  CACHE STRING "Build module testing directories")
set_property(CACHE VTK_BUILD_TESTING
  PROPERTY
    STRINGS "ON;OFF;WANT")
set(BUILD_TESTING OFF)
if (VTK_BUILD_TESTING)
  set(BUILD_TESTING ON)
endif ()

#-----------------------------------------------------------------------------
# Add an option to enable/disable components that have CUDA.
option(VTK_USE_CUDA "Support CUDA compilation" OFF)
if(VTK_USE_CUDA)
  # This needs to be a top level flag as enable_language needs
  # to be called from CMake entry point for variables to have
  # the correct scope.
  enable_language(CUDA)
endif()

#-----------------------------------------------------------------------------
# Add an option to enable/disable logging support.
option(VTK_ENABLE_LOGGING "Enable logging support." ON)
mark_as_advanced(VTK_ENABLE_LOGGING)

include(vtkEncodeString)

# Set up our directory structure for output libraries and binaries
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")

set(vtk_requested_modules)
set(vtk_rejected_modules)
if (VTK_WRAP_PYTHON)
  list(APPEND vtk_requested_modules
    VTK::WrappingPythonCore
    VTK::PythonInterpreter)
else ()
  list(APPEND vtk_rejected_modules
    VTK::Python)
endif ()
if (VTK_WRAP_JAVA)
  list(APPEND vtk_requested_modules
    VTK::Java)
else ()
  list(APPEND vtk_rejected_modules
    VTK::Java)
endif ()
# For vtkTkRenderWidget (only useful with Python, since WRAP_TCL is gone)
if (VTK_USE_TK)
  set(VTK_GROUP_ENABLE_Tk YES)
endif ()
if (VTK_USE_MPI)
  set(VTK_GROUP_ENABLE_MPI YES)
else ()
  # Reject `VTK::mpi`, but allow those which happen to be part of the group to
  # be built.
  set(_vtk_module_group_default_MPI "DONT_WANT")
  list(APPEND vtk_rejected_modules
    VTK::mpi)
endif ()
if (VTK_ENABLE_LOGGING)
  list(APPEND vtk_requested_modules
    VTK::loguru)
endif ()

if (VTK_BUILD_TESTING)
  list(APPEND vtk_requested_modules
    # Required for just about all VTK tests.
    VTK::TestingCore)
endif ()

list(APPEND vtk_requested_modules
  # Required for just about everything.
  VTK::CommonCore
  VTK::CommonDataModel)

if (VTK_ENABLE_WRAPPING)
  list(APPEND vtk_requested_modules
    # Required for wrapping with hierarchy files.
    VTK::WrappingTools)
endif ()

if (vtk_requested_modules)
  list(REMOVE_DUPLICATES vtk_requested_modules)
endif ()
if (vtk_rejected_modules)
  list(REMOVE_DUPLICATES vtk_rejected_modules)
endif ()

set_property(GLOBAL
  PROPERTY
    "_vtk_module_autoinit_include" "\"vtkAutoInit.h\"")

option(VTK_BUILD_ALL_MODULES "Build all modules by default" OFF)
mark_as_advanced(VTK_BUILD_ALL_MODULES)

# Turn on these groups by default.
set(_vtk_module_group_default_StandAlone "WANT")
set(_vtk_module_group_default_Rendering "WANT")

set(vtk_enable_tests "${VTK_BUILD_TESTING}")
if (VTK_FORBID_DOWNLOADS)
  message(STATUS "Module testing disabled due to `VTK_FORBID_DOWNLOADS` being set.")
  set(vtk_enable_tests "OFF")
endif ()

include(vtkModule)
include(vtkModuleDebugging)
set(vtk_source_directories
  "${CMAKE_CURRENT_SOURCE_DIR}/Accelerators"
  "${CMAKE_CURRENT_SOURCE_DIR}/Charts"
  "${CMAKE_CURRENT_SOURCE_DIR}/Common"
  "${CMAKE_CURRENT_SOURCE_DIR}/Domains"
  "${CMAKE_CURRENT_SOURCE_DIR}/Filters"
  "${CMAKE_CURRENT_SOURCE_DIR}/Geovis"
  "${CMAKE_CURRENT_SOURCE_DIR}/GUISupport"
  "${CMAKE_CURRENT_SOURCE_DIR}/Imaging"
  "${CMAKE_CURRENT_SOURCE_DIR}/Infovis"
  "${CMAKE_CURRENT_SOURCE_DIR}/Interaction"
  "${CMAKE_CURRENT_SOURCE_DIR}/IO"
  "${CMAKE_CURRENT_SOURCE_DIR}/Parallel"
  "${CMAKE_CURRENT_SOURCE_DIR}/Rendering"
  "${CMAKE_CURRENT_SOURCE_DIR}/Testing"
  "${CMAKE_CURRENT_SOURCE_DIR}/ThirdParty"
  "${CMAKE_CURRENT_SOURCE_DIR}/Utilities"
  "${CMAKE_CURRENT_SOURCE_DIR}/Views"
  "${CMAKE_CURRENT_SOURCE_DIR}/Web"
  "${CMAKE_CURRENT_SOURCE_DIR}/Wrapping")

set(remote_default ON)
if (VTK_WHEEL_BUILD)
  set(remote_default OFF)
endif ()
option(VTK_ENABLE_REMOTE_MODULES "Enable remote modules" ON)
mark_as_advanced(VTK_ENABLE_REMOTE_MODULES)
if (VTK_ENABLE_REMOTE_MODULES)
  list(APPEND vtk_source_directories
    "${CMAKE_CURRENT_SOURCE_DIR}/Remote")
endif ()

vtk_module_find_modules(vtk_module_files ${vtk_source_directories})
vtk_module_find_kits(vtk_kit_files ${vtk_source_directories})

# If we're building only the compile tools, limit what is done.
option(VTK_BUILD_COMPILE_TOOLS_ONLY "Build only VTK's compile tools" OFF)
mark_as_advanced(VTK_BUILD_COMPILE_TOOLS_ONLY)
if (VTK_BUILD_COMPILE_TOOLS_ONLY)
  set(vtk_requested_modules
    VTKCompileTools::WrappingTools)
  set(vtk_rejected_modules)
  set(vtk_module_files
    "${CMAKE_CURRENT_SOURCE_DIR}/Wrapping/Tools/vtkcompiletools.module")
  set(vtk_kit_files)
endif ()

cmake_dependent_option(VTK_INSTALL_SDK "Install SDK components" ON
  "NOT VTK_BUILD_COMPILE_TOOLS_ONLY" ON)
mark_as_advanced(VTK_INSTALL_SDK)

vtk_module_scan(
  MODULE_FILES        ${vtk_module_files}
  KIT_FILES           ${vtk_kit_files}
  REQUEST_MODULES     ${vtk_requested_modules}
  REJECT_MODULES      ${vtk_rejected_modules}
  PROVIDES_MODULES    vtk_modules
  PROVIDES_KITS       vtk_kits
  REQUIRES_MODULES    vtk_required_modules
  UNRECOGNIZED_MODULES vtk_unrecognized_modules
  WANT_BY_DEFAULT     "${VTK_BUILD_ALL_MODULES}"
  ENABLE_TESTS        "${vtk_enable_tests}")

if (vtk_required_modules OR vtk_unrecognized_modules)
  message(FATAL_ERROR
    "The following modules were requested or required, but not found: "
    "${vtk_required_modules};${vtk_unrecognized_modules}.")
endif ()

if ("VTK::Python" IN_LIST vtk_modules)
  include(vtkModuleWrapPython)
  if (NOT DEFINED VTK_PYTHON_SITE_PACKAGES_SUFFIX)
    vtk_module_python_default_destination(VTK_PYTHON_SITE_PACKAGES_SUFFIX)
  endif ()
endif ()

option(VTK_ENABLE_KITS "Enable kits compilation" OFF)
mark_as_advanced(VTK_ENABLE_KITS)

option(VTK_USE_EXTERNAL "Use external copies of third party libraries by default" OFF)
mark_as_advanced(VTK_USE_EXTERNAL)

option(VTK_VERSIONED_INSTALL "Install artifacts with versioned names." ON)
mark_as_advanced(VTK_VERSIONED_INSTALL)
set(vtk_version_suffix "")
if (VTK_VERSIONED_INSTALL)
  set(vtk_version_suffix "-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")
endif ()

set(vtk_install_export VTK)
if (NOT DEFINED vtk_cmake_destination)
  set(vtk_cmake_destination
    "${CMAKE_INSTALL_LIBDIR}/cmake/vtk${vtk_version_suffix}")
  set(vtk_target_package)
  if (VTK_BUILD_COMPILE_TOOLS_ONLY)
    set(vtk_install_export VTKCompileTools)
    set(vtk_cmake_destination
      "${CMAKE_INSTALL_LIBDIR}/cmake/vtkcompiletools${vtk_version_suffix}")
    set(vtk_target_package PACKAGE "${vtk_install_export}")
  endif ()
endif ()

set(VTK_CUSTOM_LIBRARY_SUFFIX "<DEFAULT>"
  CACHE STRING "Custom library file name suffix (defaults to the version number)")
mark_as_advanced(VTK_CUSTOM_LIBRARY_SUFFIX)
if (VTK_CUSTOM_LIBRARY_SUFFIX STREQUAL "<DEFAULT>")
  if (VTK_VERSIONED_INSTALL)
    set(VTK_CUSTOM_LIBRARY_SUFFIX "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")
  else ()
    set(VTK_CUSTOM_LIBRARY_SUFFIX "")
  endif ()
endif ()

vtk_module_build(
  MODULES             ${vtk_modules}
  KITS                ${vtk_kits}
  INSTALL_EXPORT      "${vtk_install_export}"
  ${vtk_target_package}
  HEADERS_DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/vtk${vtk_version_suffix}"
  ${vtk_hierarchy_destination_args}
  CMAKE_DESTINATION   "${vtk_cmake_destination}"
  LICENSE_DESTINATION "${CMAKE_INSTALL_LICENSEDIR}"
  LIBRARY_NAME_SUFFIX "${VTK_CUSTOM_LIBRARY_SUFFIX}"
  VERSION             "${VTK_VERSION}"
  SOVERSION           "1"
  TEST_DATA_TARGET    VTKData
  INSTALL_HEADERS     "${VTK_INSTALL_SDK}"
  BUILD_WITH_KITS     "${VTK_ENABLE_KITS}"
  USE_EXTERNAL        "${VTK_USE_EXTERNAL}"
  ENABLE_WRAPPING     "${VTK_ENABLE_WRAPPING}"
  TEST_INPUT_DATA_DIRECTORY   "${CMAKE_CURRENT_SOURCE_DIR}/Testing"
  TEST_OUTPUT_DATA_DIRECTORY  "${CMAKE_CURRENT_BINARY_DIR}/ExternalData/Testing")
include(vtkModuleJson)
vtk_module_json(
  MODULES ${vtk_modules}
  OUTPUT  "modules.json")
include(vtkModuleGraphviz)
vtk_module_graphviz(
  MODULES ${vtk_modules}
  KIT_CLUSTERS ON
  PRIVATE_DEPENDENCIES OFF
  OUTPUT  "modules.dot")

if (VTK_WRAP_PYTHON)
  get_property(vtk_required_python_modules GLOBAL
    PROPERTY  vtk_required_python_modules)
  if (vtk_required_python_modules)
    list(REMOVE_DUPLICATES vtk_required_python_modules)
  endif ()
  string(REPLACE ";" "\n" vtk_required_python_modules "${vtk_required_python_modules}")
  file(WRITE "${CMAKE_BINARY_DIR}/requirements.txt"
    "${vtk_required_python_modules}\n")
  get_property(vtk_soabi GLOBAL
    PROPERTY  _vtk_python_soabi)
  vtk_module_wrap_python(
    MODULES         ${vtk_modules}
    INSTALL_EXPORT  VTKPython
    PYTHON_PACKAGE  "vtkmodules"
    LIBRARY_DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    MODULE_DESTINATION  "${VTK_PYTHON_SITE_PACKAGES_SUFFIX}"
    CMAKE_DESTINATION   "${vtk_cmake_destination}"

=== Examples/CMakeLists.txt ===
project(VTKExamples)

if (VTK_BINARY_DIR)
  function (add_example dir)
    add_test(
      NAME    "VTKExample-${dir}"
      COMMAND "${CMAKE_CTEST_COMMAND}"
              --build-generator
                "${CMAKE_GENERATOR}"
              --build-and-test
                "${CMAKE_CURRENT_SOURCE_DIR}/${dir}"
                "${CMAKE_CURRENT_BINARY_DIR}/${dir}"
              --build-options
                "-DBUILD_TESTING=ON"
                "-DCMAKE_BUILD_TYPE:STRING=${CMAKE_BUILD_TYPE}"
                "-DBUILD_SHARED_LIBS:BOOL=${BUILD_SHARED_LIBS}"
                "-DVTK_DIR=${vtk_cmake_build_dir}"
                "-DQt5_DIR=${Qt5_DIR}"
              --test-command
                "${CMAKE_CTEST_COMMAND}"
                  -C $<CONFIGURATION>)
    if (WIN32)
      set(example_path "$ENV{PATH};${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")
      string(REPLACE ";" "\;" example_path "${example_path}")
      set_property(TEST "VTKExample-${dir}" APPEND
        PROPERTY
          ENVIRONMENT "PATH=${example_path}")
    endif ()
    set_property(TEST "VTKExample-${dir}" APPEND
      PROPERTY
        SKIP_REGULAR_EXPRESSION "Skipping example")
  endfunction ()
else ()
  macro (add_example dir)
    add_subdirectory("${dir}")
  endmacro ()
endif ()

if (ANDROID)
  #add_example(Android)
elseif (APPLE_IOS)
  #add_example(iOS)
else ()
  add_example(AMR/Cxx)
  add_example(Annotation/Cxx/LabeledMesh)
  #add_example(Array/Cxx)
  #add_example(Build/vtkLocal)
  add_example(Build/vtkMy)
  add_example(Charts/Cxx)
  add_example(DataManipulation/Cxx)
  add_example(GUI/Qt/FourPaneViewer)
  add_example(GUI/Qt/ImageViewer)
  add_example(GUI/Qt/SimpleView)
  add_example(GUI/Qt/TouchGestureViewer)
  add_example(IO/Cxx)
  add_example(ImageProcessing/Cxx)
  add_example(Infovis/Cxx)
  add_example(Medical/Cxx)
  add_example(Modelling/Cxx)
  add_example(MultiBlock/Cxx)
  add_example(ParallelProcessing/Generic/Cxx)
  #add_example(Rendering/Cxx)
  #add_example(Tutorial/Step1/Cxx)
  #add_example(Tutorial/Step2/Cxx)
  #add_example(Tutorial/Step3/Cxx)
  #add_example(Tutorial/Step4/Cxx)
  #add_example(Tutorial/Step5/Cxx)
  #add_example(Tutorial/Step6/Cxx)
  #add_example(VisualizationAlgorithms/Cxx)
  #add_example(VolumeRendering/Cxx)
  #add_example(Widgets/Cxx)

  add_example(Modules/UsingVTK)
  add_example(Modules/Wrapping)

  if (WIN32)
    #add_example(GUI/Win32/SimpleCxx)
    #add_example(GUI/Win32/SampleMFC)
    #add_example(GUI/Win32/vtkMFC)
  endif ()
endif ()

=== Accelerators/Vtkm/CMakeLists.txt ===
##=============================================================================
##
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##
##  Copyright 2012 Sandia Corporation.
##  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
##  the U.S. Government retains certain rights in this software.
##
##=============================================================================

list(INSERT 0 CMAKE_MODULE_PATH
  "${VTK_SOURCE_DIR}/ThirdParty/vtkm/vtkvtkm/vtk-m/CMake")

set(sources
  vtkmlib/ArrayConvertersReal.cxx
  vtkmlib/ArrayConvertersSigned.cxx
  vtkmlib/ArrayConvertersUnsigned.cxx)

set(headers
  vtkmFilterPolicy.h)

set(private_headers
  vtkmlib/ArrayConverters.hxx
  vtkmlib/Portals.hxx
  vtkmlib/PortalTraits.h
  vtkmDataArray.hxx)

set(impl_classes
  vtkmAverageToCells
  vtkmAverageToPoints
  vtkmCleanGrid
  vtkmClip
  vtkmContour
  vtkmCoordinateSystemTransform
  vtkmDataArray
  vtkmDataSet
  vtkmExternalFaces
  vtkmExtractVOI
  vtkmGradient
  vtkmHistogram
  vtkmImageConnectivity
  vtkmLevelOfDetail
  vtkmNDHistogram
  vtkmPointElevation
  vtkmPointTransform
  vtkmPolyDataNormals
  vtkmProbe
  vtkmThreshold
  vtkmTriangleMeshPointNormals
  vtkmWarpScalar
  vtkmWarpVector
  )

set(private_impl_classes
  vtkmlib/ArrayConverters
  vtkmlib/CellSetConverters
  vtkmlib/DataSetConverters
  vtkmlib/ImageDataConverter
  vtkmlib/ImplicitFunctionConverter
  vtkmlib/PolyDataConverter
  vtkmlib/Portals
  vtkmlib/UnstructuredGridConverter)

foreach (class IN LISTS impl_classes)
  list(APPEND sources "${class}.cxx")
  list(APPEND headers "${class}.h")
endforeach ()

foreach (class IN LISTS private_impl_classes)
  list(APPEND sources "${class}.cxx")
  list(APPEND private_headers "${class}.h")
endforeach ()


set(VTKM_FILTER_INCLUDE_AOS ${VTK_DISPATCH_AOS_ARRAYS})
set(VTKM_FILTER_INCLUDE_SOA ${VTK_DISPATCH_SOA_ARRAYS})
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkmConfig.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkmConfig.h"
  @ONLY)

list(APPEND headers
  "${CMAKE_CURRENT_BINARY_DIR}/vtkmConfig.h")

if (TARGET vtkm::cuda)
  enable_language(CUDA)

  # XXX(cmake#7519): Workaround for CMake which causes the c++11 flag set for
  # VTK-m using target_compile_features to not work.
  if (CMAKE_VERSION VERSION_LESS 3.11)
    set(CMAKE_CUDA_STANDARD 11)
    set(CMAKE_CUDA_STANDARD_REQUIRED True)
  endif()

  # Temporarily suppress "has address taken but no possible call to it" warnings,
  # until we figure out its implications.
  # We are disabling all warnings as nvlink has no known way to suppress
  # individual warning types.
  string(APPEND CMAKE_CUDA_FLAGS " -Xnvlink -w")
endif ()

if(TARGET vtkm::cuda AND BUILD_SHARED_LIBS)
  message("Cuda is enabled. Module VTK::AcceleratorsVTKm will be forced to build as static.")
  vtk_module_add_module(VTK::AcceleratorsVTKm
    FORCE_STATIC
    SOURCES ${sources}
    HEADERS ${headers}
    PRIVATE_HEADERS ${private_headers})
else()
  vtk_module_add_module(VTK::AcceleratorsVTKm
    SOURCES ${sources}
    HEADERS ${headers}
    PRIVATE_HEADERS ${private_headers})
endif()
_vtk_module_real_target(vtkm_accel_target VTK::AcceleratorsVTKm)
vtkm_add_target_information(${vtkm_accel_target}
                            EXTENDS_VTKM
                            MODIFY_CUDA_FLAGS
                            DEVICE_SOURCES ${sources})

vtk_module_set_property(VTK::AcceleratorsVTKm
  PROPERTY  JOB_POOL_COMPILE
  VALUE     vtkm_pool)
vtk_module_link(VTK::AcceleratorsVTKm
  PRIVATE
    vtkm_worklet
    vtkm_filter)

if (TARGET vtkm::cuda)
  vtk_module_set_property(VTK::AcceleratorsVTKm
    PROPERTY  CUDA_SEPARABLE_COMPILATION
    VALUE     ON)
  vtk_module_compile_options(VTK::AcceleratorsVTKm
    PUBLIC $<$<COMPILE_LANGUAGE:CUDA>:-Xcudafe --diag_suppress=extra_semicolon>)
endif ()

# We need to install the private headers so that consumers of VTK can write
# new VTK-m filters and do data conversions correctly.
vtk_module_install_headers(
    FILES   ${private_headers}
    SUBDIR  "vtkmlib")

if (MSVC)
  set(msvc_warning_flags
    # Generates numerous false positives with template code about unreachable
    # code
    /wd4702
    # Generates numerous warning that implicit assignment operators can't be
    # constructed. This is understood and we don't care.
    /wd4512
    # Generates numerous warning that implicit constructors can't be
    # constructed. This is understood and we don't care.
    /wd4510
    # Generates warnings when decorated names are over 4096 characters
    # This compiler warning is deprecated and no longer occurs with VS2017+.
    # So we suppress for VS2015
    /wd4503
    )
  set(vtkm_msvc_flags)
  foreach (msvc_warning_flag IN LISTS msvc_warning_flags)
    if (TARGET vtkm::cuda)
      list(APPEND vtkm_msvc_flags
        $<$<COMPILE_LANGUAGE:CUDA>:-Xcompiler=${msvc_warning_flag},${msvc_warning_flag}>)
    else ()
      list(APPEND vtkm_msvc_flags
        ${msvc_warning_flag})
    endif ()
  endforeach ()
  vtk_module_compile_options(VTK::AcceleratorsVTKm
    PRIVATE
      ${msvc_warning_flags})
endif ()

=== Common/Core/CMakeLists.txt ===
# Core configuration options.
if(CMAKE_SIZEOF_VOID_P GREATER 4)
 set(VTK_USE_64BIT_IDS_DEFAULT ON)
else()
 set(VTK_USE_64BIT_IDS_DEFAULT OFF)
 set(VTK_USE_64BIT_TIMESTAMPS_DEFAULT OFF)
 option(VTK_USE_64BIT_TIMESTAMPS "Build VTK with 64 bit timestamps"
  ${VTK_USE_64BIT_TIMESTAMPS_DEFAULT})
endif()

option(VTK_USE_64BIT_IDS "Build VTK with 64 bit ids"
  ${VTK_USE_64BIT_IDS_DEFAULT})
mark_as_advanced(VTK_USE_64BIT_IDS)

option(VTK_DEBUG_LEAKS "Build leak checking support into VTK." OFF)
mark_as_advanced(VTK_DEBUG_LEAKS)
include(CMakeDependentOption)
# See vtkDataArrayRange.h docs for more info on these:
cmake_dependent_option(VTK_DEBUG_RANGE_ITERATORS
  "Detect usage errors with the for-range iterators (SLOW)." OFF
  "CMAKE_BUILD_TYPE STREQUAL \"Debug\"" OFF)
mark_as_advanced(VTK_DEBUG_RANGE_ITERATORS)
cmake_dependent_option(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS
  "Enable additional optimizations for array iterators in Debug builds." OFF
  "NOT VTK_DEBUG_RANGE_ITERATORS" OFF)
mark_as_advanced(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS)

# This option determines the behavior of the New methods of vtkObject derived
# classes. If this option is off then only classes specifically using the
# vtkObjectFactoryNewMacro and vtkAbstractObjectFactoryNewMacro will allow for
# overrides. If the method is on then vtkStandardNewMacro will use the
# vtkObjectFactoryNewMacro's implementation body.
option(VTK_ALL_NEW_OBJECT_FACTORY
  "Build all vtkObject derived classes with object factory new methods." OFF)
mark_as_advanced(VTK_ALL_NEW_OBJECT_FACTORY)

set(vtk_smp_sources)
set(vtk_smp_headers)
set(vtk_smp_defines)
set(vtk_smp_libraries)
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkSMPSelection.cmake")

# Generate the vtkTypeList_Create macros:
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateTypeListMacros.cmake")
CreateTypeListMacros(
  VTK_TYPELISTMACRO_HEADER_CONTENTS
  99
  vtkTypeList_Create
  "vtkTypeList::TypeList"
  "vtkTypeList::NullType")
configure_file(vtkTypeListMacros.h.in vtkTypeListMacros.h)

# And the ArrayDispatch array list header:
option(VTK_DISPATCH_AOS_ARRAYS "Include array-of-structs vtkDataArray subclasses in dispatcher." ON)
option(VTK_DISPATCH_SOA_ARRAYS "Include struct-of-arrays vtkDataArray subclasses in dispatcher." OFF)
option(VTK_DISPATCH_TYPED_ARRAYS "Include vtkTypedDataArray subclasses (e.g. old mapped arrays) in dispatcher." OFF)
option(VTK_WARN_ON_DISPATCH_FAILURE "If enabled, vtkArrayDispatch will print a warning when a dispatch fails." OFF)
mark_as_advanced(
  VTK_DISPATCH_AOS_ARRAYS
  VTK_DISPATCH_SOA_ARRAYS
  VTK_DISPATCH_TYPED_ARRAYS
  VTK_WARN_ON_DISPATCH_FAILURE)

option(VTK_BUILD_SCALED_SOA_ARRAYS "Include struct-of-arrays with scaled vtkDataArray implementation." OFF)

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateArrayDispatchArrayList.cmake")
vtkArrayDispatch_default_array_setup()
vtkArrayDispatch_generate_array_header(VTK_ARRAYDISPATCH_ARRAY_LIST)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkArrayDispatchArrayList.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkArrayDispatchArrayList.h"
  @ONLY)

set(classes
  vtkAbstractArray
  vtkAnimationCue
  vtkArchiver
  vtkArray
  vtkArrayCoordinates
  vtkArrayExtents
  vtkArrayExtentsList
  vtkArrayIterator
  vtkArrayRange
  vtkArraySort
  vtkArrayWeights
  vtkBitArray
  vtkBitArrayIterator
  vtkBoxMuellerRandomSequence
  vtkBreakPoint
  vtkByteSwap
  vtkCallbackCommand
  vtkCharArray
  vtkCollection
  vtkCollectionIterator
  vtkCommand
  vtkCommonInformationKeyManager
  vtkConditionVariable
  vtkCriticalSection
  vtkDataArray
  vtkDataArrayCollection
  vtkDataArrayCollectionIterator
  vtkDataArraySelection
  vtkDebugLeaks
  vtkDebugLeaksManager
  vtkDoubleArray
  vtkDynamicLoader
  vtkEventForwarderCommand
  vtkFileOutputWindow
  vtkFloatArray
  vtkFloatingPointExceptions
  vtkGarbageCollector
  vtkGarbageCollectorManager
  vtkGaussianRandomSequence
  vtkIdList
  vtkIdListCollection
  vtkIdTypeArray
  vtkIndent
  vtkInformation
  vtkInformationDataObjectKey
  vtkInformationDoubleKey
  vtkInformationDoubleVectorKey
  vtkInformationIdTypeKey
  vtkInformationInformationKey
  vtkInformationInformationVectorKey
  vtkInformationIntegerKey
  vtkInformationIntegerPointerKey
  vtkInformationIntegerVectorKey
  vtkInformationIterator
  vtkInformationKey
  vtkInformationKeyLookup
  vtkInformationKeyVectorKey
  vtkInformationObjectBaseKey
  vtkInformationObjectBaseVectorKey
  vtkInformationRequestKey
  vtkInformationStringKey
  vtkInformationStringVectorKey
  vtkInformationUnsignedLongKey
  vtkInformationVariantKey
  vtkInformationVariantVectorKey
  vtkInformationVector
  vtkIntArray
  vtkLargeInteger
  vtkLogger
  vtkLongArray
  vtkLongLongArray
  vtkLookupTable
  vtkMath
  vtkMersenneTwister
  vtkMinimalStandardRandomSequence
  vtkMultiThreader
  vtkMutexLock
  vtkOStrStreamWrapper
  vtkOStreamWrapper
  vtkObject
  vtkObjectBase
  vtkObjectFactory
  vtkObjectFactoryCollection
  vtkOldStyleCallbackCommand
  vtkOutputWindow
  vtkOverrideInformation
  vtkOverrideInformationCollection
  vtkPoints
  vtkPoints2D
  vtkPriorityQueue
  vtkRandomPool
  vtkRandomSequence
  vtkReferenceCount
  vtkScalarsToColors
  vtkShortArray
  vtkSignedCharArray
  vtkSimpleCriticalSection
  vtkSmartPointerBase
  vtkSortDataArray
  vtkStdString
  vtkStringArray
  vtkStringOutputWindow
  vtkTimePointUtility
  vtkTimeStamp
  vtkUnicodeString
  vtkUnicodeStringArray
  vtkUnsignedCharArray
  vtkUnsignedIntArray
  vtkUnsignedLongArray
  vtkUnsignedLongLongArray
  vtkUnsignedShortArray
  vtkVariant
  vtkVariantArray
  vtkVersion
  vtkVoidArray
  vtkWeakPointerBase
  vtkWeakReference
  vtkWindow
  vtkXMLFileOutputWindow)

set(template_classes
  vtkAOSDataArrayTemplate
  vtkArrayDispatch
  vtkArrayInterpolate
  vtkArrayIteratorTemplate
  vtkArrayPrint
  vtkDenseArray
  vtkGenericDataArray
  vtkMappedDataArray
  vtkSOADataArrayTemplate
  vtkSparseArray
  vtkTypedArray
  vtkTypedDataArray
  vtkTypeList)

set(sources
  vtkArrayIteratorTemplateInstantiate.cxx
  vtkGenericDataArray.cxx
  vtkSOADataArrayTemplateInstantiate.cxx
  ${vtk_smp_sources})

if (VTK_BUILD_SCALED_SOA_ARRAYS)
  list (APPEND template_classes vtkScaledSOADataArrayTemplate)
  list (APPEND sources  vtkScaledSOADataArrayTemplateInstantiate.cxx)
  set(VTK_USE_SCALED_SOA_ARRAYS 1)
endif ()
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkVTK_USE_SCALED_SOA_ARRAYS.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVTK_USE_SCALED_SOA_ARRAYS.h")

set(headers
  vtkABI.h
  vtkArrayIteratorIncludes.h
  vtkAssume.h
  vtkAtomicTypeConcepts.h
  vtkAutoInit.h
  vtkBuffer.h
  vtkCollectionRange.h
  vtkDataArrayAccessor.h
  vtkDataArrayIteratorMacro.h
  vtkDataArrayMeta.h
  vtkDataArrayRange.h
  vtkDataArrayTemplate.h
  vtkDataArrayTupleRange_AOS.h
  vtkDataArrayTupleRange_Generic.h
  vtkDataArrayValueRange_AOS.h
  vtkDataArrayValueRange_Generic.h
  vtkEventData.h
  vtkGenericDataArrayLookupHelper.h
  vtkIOStream.h
  vtkIOStreamFwd.h
  vtkInformationInternals.h
  vtkMathUtilities.h
  vtkMeta.h
  vtkNew.h
  vtkRange.h
  vtkRangeIterableTraits.h
  vtkSetGet.h
  vtkSmartPointer.h
  vtkSystemIncludes.h
  vtkTemplateAliasMacro.h
  vtkTestDataArray.h
  vtkType.h
  vtkTypeTraits.h
  vtkTypedDataArrayIterator.h
  vtkVariantCast.h
  vtkVariantCreate.h
  vtkVariantExtract.h
  vtkVariantInlineOperators.h
  vtkWeakPointer.h
  vtkWin32Header.h
  vtkWindows.h
  vtkWrappingHints.h
  ${vtk_smp_headers}
  "${CMAKE_CURRENT_BINARY_DIR}/vtkArrayDispatchArrayList.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkConfigure.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkMathConfigure.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkToolkits.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkTypeListMacros.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVersionMacros.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVTK_USE_SCALED_SOA_ARRAYS.h")

set(private_headers
  "${CMAKE_CURRENT_BINARY_DIR}/vtkFloatingPointExceptionsConfigure.h")

set(templates
  vtkArrayIteratorTemplateImplicit.txx)

set(private_templates
  vtkDataArrayPrivate.txx)

set(vtk_include_dirs)

vtk_module_find_package(
  PACKAGE Threads)

set(VTK_MAX_THREADS "64" CACHE STRING
  "Max number of threads vtkMultiThreader will allocate.")
mark_as_advanced(VTK_MAX_THREADS)

if (CMAKE_USE_PTHREADS_INIT AND CMAKE_USE_WIN32_THREADS_INIT)
  if (DEFINED _vtk_thread_impl_output)
    set(thread_impl_output "${_vtk_thread_impl_output}")
  else ()
    execute_process(
      COMMAND "${CMAKE_C_COMPILER}" -v
      OUTPUT_VARIABLE thread_impl_output
      ERROR_VARIABLE  thread_impl_output
      RESULT_VARIABLE result
      TIMEOUT         10)
    if (result)
      message(FATAL_ERROR
        "Failed to determine the thread implementation in use by the "
        "compiler.")
    endif ()
    string (REGEX REPLACE ".*Thread model: \((posix|win32)\).*" "\\1" thread_impl_output "${thread_impl_output}")
  endif ()
  set(_vtk_thread_impl_output "${thread_impl_output}"
    CACHE INTERNAL "thread model detection")
  if (thread_impl_output MATCHES "posix")
    set(VTK_USE_PTHREADS 1)
  elseif (thread_impl_output MATCHES "win32")
    set(VTK_USE_WIN32_THREADS 1)
  else ()
    set(VTK_USE_PTHREADS 1)
  endif ()
elseif (CMAKE_USE_PTHREADS_INIT)
  set(VTK_USE_PTHREADS 1)
elseif (CMAKE_USE_WIN32_THREADS_INIT)
  set(VTK_USE_WIN32_THREADS 1)
endif ()

# We can't check for the target since we're before VTK::CommonDataModel in the
# dependency graph.
if (VTK_MODULE_ENABLE_VTK_CommonDataModel)
  list(APPEND vtk_include_dirs
    "${CMAKE_CURRENT_BINARY_DIR}/../DataModel")
  set_property(SOURCE vtkInformationDataObjectKey.cxx
    PROPERTY
      COMPILE_DEFINITIONS vtkCommonDataModel_ENABLED)
endif ()

if(WIN32)
  list(APPEND classes
    vtkWin32OutputWindow
    vtkWin32ProcessOutputWindow)
  list(APPEND sources
    vtkWin32OutputWindowProcessEncoded.c)
endif()

if(ANDROID)
  list(APPEND classes
    vtkAndroidOutputWindow)
endif()

# Platform configuration tests.
include(TestBigEndian)
test_big_endian(VTK_WORDS_BIGENDIAN)

# Provide version macros through vtkConfigure.h for compatibility.
if(VTK_LEGACY_REMOVE)
  set(VTK_CONFIG_LEGACY_VERSION "")
else()
  set(VTK_CONFIG_LEGACY_VERSION "#include \"vtkVersionMacros.h\" // removed by VTK_LEGACY_REMOVE")
endif()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkVersionMacros.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVersionMacros.h"
  @ONLY)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkConfigure.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkConfigure.h"
  @ONLY)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkToolkits.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkToolkits.h"
  @ONLY)

add_custom_command(
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/CaseFolding.txt"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/vtkUnicodeString.cmake"
  COMMAND "${CMAKE_COMMAND}"
          "-Dsource_dir=${CMAKE_CURRENT_SOURCE_DIR}"
          "-Dbinary_dir=${CMAKE_CURRENT_BINARY_DIR}"
          -P "${CMAKE_CURRENT_SOURCE_DIR}/vtkUnicodeString.cmake"
  OUTPUT  "${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeCaseFoldData.h")

set_source_files_properties(vtkUnicodeString.cxx
  PROPERTIES
    OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/vtkUnicodeCaseFoldData.h")

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkTypeArrays.cmake")

include(CheckCXXSourceCompiles)

macro(CHECK_CXX_EXPRESSION_COMPILES EXPRESSION FILES VARIABLE)
  set(SOURCE "/* CHECK_CXX_EXPRESSION_COMPILES */\n")
  foreach(FILE ${FILES})
    set(SOURCE "${SOURCE}#include <${FILE}>\n")
  endforeach()
  set(SOURCE "${SOURCE}\nint main()\n{\n")
  set(SOURCE "${SOURCE}  static_cast<void>(${EXPRESSION});\n\n")
  set(SOURCE "${SOURCE}  return 0;\n}\n")
  check_cxx_source_compiles("${SOURCE}" "${VARIABLE}")
endmacro()

# Check C++ <cmath> first, where the C++11 standard says these must be.
check_cxx_expression_compiles("std::isnan(0.0)" "cmath" VTK_HAS_STD_ISNAN)
check_cxx_expression_compiles("std::isinf(0.0)" "cmath" VTK_HAS_STD_ISINF)
check_cxx_expression_compiles("std::isfinite(0.0)" "cmath" VTK_HAS_STD_ISFINITE)

include(CheckSymbolExists)

# Check C99 <math.h> next, where the C99 standard says these must be.

=== Common/ExecutionModel/CMakeLists.txt ===
set(classes
  vtkAlgorithm
  vtkAlgorithmOutput
  vtkAnnotationLayersAlgorithm
  vtkArrayDataAlgorithm
  vtkCachedStreamingDemandDrivenPipeline
  vtkCastToConcrete
  vtkCompositeDataPipeline
  vtkCompositeDataSetAlgorithm
  vtkDataObjectAlgorithm
  vtkDataSetAlgorithm
  vtkDemandDrivenPipeline
  vtkDirectedGraphAlgorithm
  vtkEnsembleSource
  vtkExecutive
  vtkExplicitStructuredGridAlgorithm
  vtkExtentRCBPartitioner
  vtkExtentSplitter
  vtkExtentTranslator
  vtkFilteringInformationKeyManager
  vtkGraphAlgorithm
  vtkHierarchicalBoxDataSetAlgorithm
  vtkHyperTreeGridAlgorithm
  vtkImageAlgorithm
  vtkImageInPlaceFilter
  vtkImageProgressIterator
  vtkImageToStructuredGrid
  vtkImageToStructuredPoints
  vtkInformationDataObjectMetaDataKey
  vtkInformationExecutivePortKey
  vtkInformationExecutivePortVectorKey
  vtkInformationIntegerRequestKey
  vtkMoleculeAlgorithm
  vtkMultiBlockDataSetAlgorithm
  vtkMultiTimeStepAlgorithm
  vtkParallelReader
  vtkPassInputTypeAlgorithm
  vtkPiecewiseFunctionAlgorithm
  vtkPiecewiseFunctionShiftScale
  vtkPointSetAlgorithm
  vtkPolyDataAlgorithm
  vtkProgressObserver
  vtkReaderAlgorithm
  vtkReaderExecutive
  vtkRectilinearGridAlgorithm
  vtkSMPProgressObserver
  vtkScalarTree
  vtkSelectionAlgorithm
  vtkSimpleImageToImageFilter
  vtkSimpleReader
  vtkSimpleScalarTree
  vtkSpanSpace
  vtkSphereTree
  vtkStreamingDemandDrivenPipeline
  vtkStructuredGridAlgorithm
  vtkTableAlgorithm
  vtkThreadedCompositeDataPipeline
  vtkThreadedImageAlgorithm
  vtkTreeAlgorithm
  vtkTrivialConsumer
  vtkTrivialProducer
  vtkUndirectedGraphAlgorithm
  vtkUniformGridPartitioner
  vtkUnstructuredGridAlgorithm
  vtkUnstructuredGridBaseAlgorithm

  # New AMR classes
  vtkNonOverlappingAMRAlgorithm
  vtkOverlappingAMRAlgorithm
  vtkUniformGridAMRAlgorithm)

vtk_module_add_module(VTK::CommonExecutionModel
  CLASSES ${classes})

=== Common/Math/CMakeLists.txt ===
set(classes
  vtkAmoebaMinimizer
  vtkFunctionSet
  vtkInitialValueProblemSolver
  vtkMatrix3x3
  vtkMatrix4x4
  vtkPolynomialSolversUnivariate
  vtkQuaternionInterpolator
  vtkRungeKutta2
  vtkRungeKutta4
  vtkRungeKutta45)

set(template_classes
  vtkQuaternion)

set(headers
  vtkTuple.h)

if(CMAKE_COMPILER_IS_GNUCXX)
  set_source_files_properties(vtkPolynomialSolversUnivariate.cxx
    PROPERTIES
      COMPILE_FLAGS -O0)
endif()

vtk_module_add_module(VTK::CommonMath
  CLASSES           ${classes}
  TEMPLATE_CLASSES  ${template_classes}
  HEADERS           ${headers})

=== Common/Python/CMakeLists.txt ===
set(classes
  vtkPythonArchiver)

vtk_module_add_module(VTK::CommonPython
  CLASSES ${classes})

=== Common/System/CMakeLists.txt ===
vtk_module_find_package(
  PACKAGE Threads)

set(classes
  vtkClientSocket
  vtkDirectory
  vtkServerSocket
  vtkSocket
  vtkSocketCollection
  vtkThreadMessager
  vtkTimerLog)

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkTestSocketFeatures.cmake")

set(vtkSocket_defines)
if (VTK_HAVE_GETSOCKNAME_WITH_SOCKLEN_T)
  list(APPEND vtkSocket_defines "VTK_HAVE_GETSOCKNAME_WITH_SOCKLEN_T")
endif ()
if (VTK_HAVE_SO_REUSEADDR)
  list(APPEND vtkSocket_defines "VTK_HAVE_SO_REUSEADDR")
endif ()
if(VTK_NO_PLATFORM_SOCKETS)
  list(APPEND vtkSocket_defines "VTK_SOCKET_FAKE_API")
endif()

set_source_files_properties(vtkSocket.cxx
  PROPERTIES
    COMPILE_DEFINITIONS "${vtkSocket_defines}")

vtk_module_add_module(VTK::CommonSystem
  CLASSES ${classes})
vtk_module_link(VTK::CommonSystem
  PRIVATE
    $<$<PLATFORM_ID:WIN32>:wsock32>
    Threads::Threads)

=== Domains/Chemistry/CMakeLists.txt ===
set(classes
  vtkBlueObeliskData
  vtkBlueObeliskDataParser
  vtkCMLMoleculeReader
  vtkGaussianCubeReader2
  vtkMoleculeMapper
  vtkMoleculeToAtomBallFilter
  vtkMoleculeToBondStickFilter
  vtkMoleculeToLinesFilter
  vtkMoleculeToPolyDataFilter
  vtkPeriodicTable
  vtkPointSetToMoleculeFilter
  vtkProgrammableElectronicData
  vtkProteinRibbonFilter
  vtkSimpleBondPerceiver
  vtkVASPAnimationReader
  vtkVASPTessellationReader
  vtkXYZMolReader2)

# Generate configured header file
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkChemistryConfigure.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkChemistryConfigure.h"
  @ONLY)

vtk_module_add_module(VTK::DomainsChemistry
  CLASSES ${classes}
  HEADERS "${CMAKE_CURRENT_BINARY_DIR}/vtkChemistryConfigure.h"
  PRIVATE_HEADERS vtkBlueObeliskDataInternal.h)

=== Domains/ParallelChemistry/CMakeLists.txt ===
set(classes
  vtkPSimpleBondPerceiver)

vtk_object_factory_declare(
  BASE      vtkSimpleBondPerceiver
  OVERRIDE  vtkPSimpleBondPerceiver)

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKDOMAINSPARALLELCHEMISTRY_EXPORT")

vtk_module_add_module(VTK::DomainsParallelChemistry
  CLASSES ${classes}
  SOURCES ${vtk_object_factory_source}
  PRIVATE_HEADERS ${vtk_object_factory_header})

=== Filters/Core/CMakeLists.txt ===
set(classes
  vtk3DLinearGridPlaneCutter
  vtkAppendArcLength
  vtkAppendCompositeDataLeaves
  vtkAppendDataSets
  vtkAppendFilter
  vtkAppendPolyData
  vtkAppendSelection
  vtkArrayCalculator
  vtkAssignAttribute
  vtkAttributeDataToFieldDataFilter
  vtkBinCellDataFilter
  vtkCellDataToPointData
  vtkCellCenters
  vtkCenterOfMass
  vtkCleanPolyData
  vtkClipPolyData
  vtkCompositeCutter
  vtkCompositeDataProbeFilter
  vtkConnectivityFilter
  vtkContour3DLinearGrid
  vtkContourFilter
  vtkContourGrid
  vtkContourHelper
  vtk3DLinearGridCrinkleExtractor
  vtkCutter
  vtkDataObjectGenerator
  vtkDataObjectToDataSetFilter
  vtkDataSetEdgeSubdivisionCriterion
  vtkDataSetToDataObjectFilter
  vtkDecimatePolylineFilter
  vtkDecimatePro
  vtkDelaunay2D
  vtkDelaunay3D
  vtkEdgeSubdivisionCriterion
  vtkElevationFilter
  vtkExecutionTimer
  vtkExplicitStructuredGridCrop
  vtkExplicitStructuredGridToUnstructuredGrid
  vtkFeatureEdges
  vtkFieldDataToAttributeDataFilter
  vtkFlyingEdges2D
  vtkFlyingEdges3D
  vtkFlyingEdgesPlaneCutter
  vtkGlyph2D
  vtkGlyph3D
  vtkGridSynchronizedTemplates3D
  vtkHedgeHog
  vtkHull
  vtkIdFilter
  vtkImageDataToExplicitStructuredGrid
  vtkImageAppend
  vtkImplicitPolyDataDistance
  vtkImplicitProjectOnPlaneDistance
  vtkMarchingCubes
  vtkMarchingSquares
  vtkMaskFields
  vtkMaskPoints
  vtkMaskPolyData
  vtkMassProperties
  vtkMergeDataObjectFilter
  vtkMergeFields
  vtkMergeFilter
  vtkMoleculeAppend
  vtkMultiObjectMassProperties
  vtkPlaneCutter
  vtkPointDataToCellData
  vtkPolyDataConnectivityFilter
  vtkPolyDataNormals
  vtkPolyDataTangents
  vtkProbeFilter
  vtkQuadricClustering
  vtkQuadricDecimation
  vtkRearrangeFields
  vtkRectilinearSynchronizedTemplates
  vtkRemoveDuplicatePolys
  vtkResampleToImage
  vtkResampleWithDataSet
  vtkReverseSense
  vtkSimpleElevationFilter
  vtkSmoothPolyDataFilter
  vtkSphereTreeFilter
  vtkStaticCleanPolyData
  vtkStreamerBase
  vtkStreamingTessellator
  vtkStripper
  vtkStructuredGridAppend
  vtkStructuredGridOutlineFilter
  vtkSynchronizedTemplates2D
  vtkSynchronizedTemplates3D
  vtkSynchronizedTemplatesCutter3D
  vtkTensorGlyph
  vtkThreshold
  vtkThresholdPoints
  vtkTransposeTable
  vtkTriangleFilter
  vtkTriangleMeshPointNormals
  vtkTubeFilter
  vtkUnstructuredGridQuadricDecimation
  vtkUnstructuredGridToExplicitStructuredGrid
  vtkVectorDot
  vtkVectorNorm
  vtkVoronoi2D
  vtkWindowedSincPolyDataFilter)

set(headers
    vtk3DLinearGridInternal.h)

vtk_module_add_module(VTK::FiltersCore
  CLASSES ${classes})

=== Filters/Extraction/CMakeLists.txt ===
set(classes
  vtkBlockSelector
  vtkConvertSelection
  vtkExpandMarkedElements
  vtkExtractBlock
  vtkExtractCells
  vtkExtractCellsByType
  vtkExtractDataArraysOverTime
  vtkExtractDataOverTime
  vtkExtractDataSets
  vtkExtractEdges
  vtkExtractExodusGlobalTemporalVariables
  vtkExtractGeometry
  vtkExtractGrid
  vtkExtractLevel
  vtkExtractPolyDataGeometry
  vtkExtractRectilinearGrid
  vtkExtractSelectedArraysOverTime
  vtkExtractSelectedBlock
  vtkExtractSelectedIds
  vtkExtractSelectedLocations
  vtkExtractSelectedPolyDataIds
  vtkExtractSelectedRows
  vtkExtractSelectedThresholds
  vtkExtractSelection
  vtkExtractTensorComponents
  vtkExtractTimeSteps
  vtkExtractUnstructuredGrid
  vtkExtractVectorComponents
  vtkFrustumSelector
  vtkHierarchicalDataExtractDataSets
  vtkHierarchicalDataExtractLevel
  vtkLocationSelector
  vtkProbeSelectedLocations
  vtkSelector
  vtkValueSelector)

if (NOT VTK_LEGACY_REMOVE)
  list(APPEND classes
    vtkExtractTemporalFieldData)
endif()

vtk_module_add_module(VTK::FiltersExtraction
  CLASSES ${classes})

=== debian/changelog ===
vtk9 (9.0.1+dfsg1-8~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 06 Jul 2021 11:41:45 -0700

vtk9 (9.0.1+dfsg1-8~bpo10+2) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * [e29d142] Set minimal gl2ps version to 1.4.2

 -- Anton Gladky <gladk@debian.org>  Tue, 16 Mar 2021 20:49:01 +0100

vtk9 (9.0.1+dfsg1-8~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Anton Gladky <gladk@debian.org>  Sat, 06 Feb 2021 22:20:03 +0100

vtk9 (9.0.1+dfsg1-8) unstable; urgency=medium

  [ Samuel Thibault ]
  * [e2a0f2b]  Fix java dep on non-java ports. (Closes: #980125)

 -- Anton Gladky <gladk@debian.org>  Thu, 14 Jan 2021 21:36:46 +0100

vtk9 (9.0.1+dfsg1-7) unstable; urgency=medium

  * [cab8734] Enable some more modules

 -- Anton Gladky <gladk@debian.org>  Thu, 07 Jan 2021 19:43:49 +0100

vtk9 (9.0.1+dfsg1-6) unstable; urgency=medium

  [ Samuel Thibault ]
  * [7027348] Fix FTBFS on hurd-i386 and non-java ports. (Closes: #978659)

  [ Vagrant Cascadian ]
  * [7a3a0e0] Make vtk9 build-reproducible. (Closes: #977522, #977521)

  [ Anton Gladky ]
  * [a341c32] Enable RenderingContextOpenGL2. (Closes: #979073)

 -- Anton Gladky <gladk@debian.org>  Mon, 04 Jan 2021 22:12:05 +0100

vtk9 (9.0.1+dfsg1-5) unstable; urgency=medium

  [ Adrian Bunk ]
  * [06163ff] Fixes and workaround for platforms where Qt uses OpenGL ES

  [ Anton Gladky ]
  * [3e6d9ec] Ignore quilt dir
  * [294ca1e] Revert "Do not build qt on some (GLES) archs"

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Dec 2020 12:55:42 +0100

vtk9 (9.0.1+dfsg1-4) unstable; urgency=medium

  * [b80e4ab] Do not build qt on some (GLES) archs

 -- Anton Gladky <gladk@debian.org>  Sun, 13 Dec 2020 12:14:22 +0100

vtk9 (9.0.1+dfsg1-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * [52af841] Revert "Link against latomic"
  * [381ea98] Link with libatomic on archtectures that need it

  [ Anton Gladky ]
  * [a983346] 80_allow_gles_platforms.patch.
  * [e79137e] Fix FTBFS against freetype 2.10.4. (Closes: #976975)
  * [d7ecb86] Add python3-vtk9 as Breaks+Replaces: python3-paraview.
              (Closes: #976127)
  * [19fe54e] Update changelog.

 -- Anton Gladky <gladk@debian.org>  Thu, 10 Dec 2020 17:33:59 +0100

vtk9 (9.0.1+dfsg1-2) unstable; urgency=medium

  * [3afb408] Fix autopkgtests
  * [8c41fa9] Minor fix in d/copyright

 -- Anton Gladky <gladk@debian.org>  Wed, 25 Nov 2020 21:50:59 +0100

vtk9 (9.0.1+dfsg1-1) unstable; urgency=medium

  * [6b297c8] Link against latomic
  * Upload into unstable

 -- Anton Gladky <gladk@debian.org>  Thu, 19 Nov 2020 19:59:45 +0100

vtk9 (9.0.1+dfsg1-1~exp6) experimental; urgency=medium

  * [751a92f] Remove Qt-files from non-qt binaries. (Closes: #974923)

 -- Anton Gladky <gladk@debian.org>  Mon, 16 Nov 2020 21:39:46 +0100

vtk9 (9.0.1+dfsg1-1~exp5) experimental; urgency=medium

  * [21adbaf] Fix FTBFS
  * [4326c39] Sort build-dependencies

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Nov 2020 08:47:31 +0100

vtk9 (9.0.1+dfsg1-1~exp4) experimental; urgency=medium

  * [0be2017] Drop Build-Depends-Arch:

 -- Anton Gladky <gladk@debian.org>  Fri, 13 Nov 2020 23:29:02 +0100

vtk9 (9.0.1+dfsg1-1~exp3) experimental; urgency=medium

  * [e5cfe7f] Move javahelper to BD

 -- Anton Gladky <gladk@debian.org>  Fri, 13 Nov 2020 22:53:27 +0100

vtk9 (9.0.1+dfsg1-1~exp2) experimental; urgency=medium

  * [cedb51e] Fix FTBFS on -any arch

 -- Anton Gladky <gladk@debian.org>  Fri, 13 Nov 2020 16:07:58 +0100

vtk9 (9.0.1+dfsg1-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #974165)

 -- Anton Gladky <gladk@debian.org>  Tue, 10 Nov 2020 22:12:50 +0100

=== debian/control ===
Source: vtk9
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>,
           Gert Wollny <gewo@debian.org>,
           Nico Schlömer <nico.schloemer@gmail.com>
Section: graphics
Priority: optional
Build-Depends: chrpath,
               cmake (>= 3.2.0),
               debhelper-compat (= 13),
               default-jdk [!hppa !hurd-any !kfreebsd-any],
               default-libmysqlclient-dev,
               dh-python,
               doxygen-latex,
               ghostscript,
               gnuplot-nox,
               graphviz,
               hdf5-tools,
               javahelper,
               libalglib-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libdigest-md5-perl,
               libdouble-conversion-dev,
               libeigen3-dev,
               libexpat-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libftgl-dev,
               libgdal-dev,
               libgl1-mesa-dev | libgl-dev,
               libgl2ps-dev (>= 1.4.2),
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libhdf5-openmpi-dev,
               libhpdf-dev,
               libjpeg-dev,
               libjs-mathjax,
               libjsoncpp-dev,
               liblz4-dev,
               libmrmpi-dev,
               libnetcdf-cxx-legacy-dev,
               libnetcdf-dev,
               libogg-dev,
               libosmesa6-dev,
               libpng-dev,
               libpq-dev,
               libproj-dev,
               libsqlite3-dev,
               libswscale-dev,
               libtheora-dev,
               libtiff-dev,
               libutfcpp-dev,
               libx11-dev,
               libxdmf-dev,
               libxml2-dev,
               libxpm-dev,
               libxt-dev,
               lzma,
               mpi-default-dev,
               pkg-config,
               python3-all-dev,
               python3-matplotlib,
               python3-mpi4py,
               qtbase5-dev,
               r-base,
               r-base-core,
               r-base-dev,
               tcl-dev,
               texlive-binaries,
               tk-dev,
               x11proto-core-dev,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/vtk9
Vcs-Git: https://salsa.debian.org/science-team/vtk9.git
Homepage: https://www.vtk.org/

Package: libvtk9-dev
Architecture: any
Section: libdevel
Depends: default-jdk [!hppa !hurd-any !kfreebsd-any],
         default-libmysqlclient-dev,
         libavcodec-dev,
         libavformat-dev,
         libavutil-dev,
         libc6-dev,
         libdouble-conversion-dev,
         libeigen3-dev,
         libexpat-dev,
         libfreetype6-dev,
         libgdal-dev,
         libgl1-mesa-dev | libgl-dev,
         libgl2ps-dev,
         libglew-dev,
         libglu1-mesa-dev | libglu-dev,
         libhdf5-mpi-dev,
         libjpeg-dev,
         libjsoncpp-dev,
         liblz4-dev,
         libnetcdf-cxx-legacy-dev,
         libnetcdf-dev,
         libpng-dev,
         libpq-dev,
         libproj-dev,
         libpython3-dev,
         libswscale-dev,
         libtheora-dev,
         libtiff-dev,
         libutfcpp-dev,
         libvtk9 (= ${binary:Version}),
         libvtk9-java (= ${binary:Version}) [!hppa !hurd-any !kfreebsd-any],
         libx11-dev,
         libxft-dev,
         libxml2-dev,
         libxss-dev,
         libxt-dev,
         mpi-default-dev,
         python3-vtk9 (= ${binary:Version}),
         tcl-dev,
         tk-dev,
         vtk9 (= ${binary:Version}),
         x11proto-core-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: vtk9-doc, vtk9-examples
Conflicts: libvtk5-dev, libvtk6-dev, libvtk7-dev
Replaces: libvtk5-dev, libvtk6-dev, libvtk7-dev
Description: VTK header files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation.

Package: libvtk9
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: mpi-default-bin, vtk9-doc, vtk9-examples
Replaces: libvtk5.8, libvtk7.1
Description: VTK libraries
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK.

Package: libvtk9-java
Architecture: alpha amd64 arm64 armel armhf i386 ia64 m68k mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: java-virtual-machine,
          libvtk9-dev (= ${binary:Version}),
          vtk9-doc,
          vtk9-examples
Replaces: libvtk6-java, libvtk7-java
Breaks: libvtk6-java, libvtk7-java
Description: VTK - Java language support
 The Visualization Toolkit (VTK) is an object oriented, high level
 library that allows one to easily write C++ programs, Tcl, Python and
 Java scripts that do 3D visualization.
 .
 This package provides the VTK Java language support.

Package: python3-vtk9
Architecture: any
Section: python
Depends: libvtk9 (= ${binary:Version}),
         python3-mpi4py,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: mayavi2, vtk9-doc, vtk9-examples
Breaks: python3-paraview (<< 5.9.0~rc1-1~), python3-vtk6, python3-vtk7
Replaces: python3-paraview (<< 5.9.0~rc1-1~), python3-vtk6, python3-vtk7
Description: Python bindings for VTK
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the python3 bindings for VTK.

Package: vtk9
Architecture: any
Section: interpreters
Depends: libvtk9 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: vtk9-doc, vtk9-examples
Description: Binaries for VTK9
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides binaries for VTK9

Package: vtk9-doc
Architecture: all
Section: doc
Depends: doc-base, libjs-jquery, libjs-mathjax, ${misc:Depends}
Suggests: libvtk9-dev, vtk9-examples
Description: VTK class reference documentation
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides documentation for VTK9

Package: vtk9-examples
Architecture: all
Depends: ${misc:Depends}
Suggests: libvtk9-dev, python3, python3-vtk9, vtk9-doc
Description: VTK examples
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides examples for VTK9

Package: libvtk9-qt
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: VTK libraries, Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the shared libraries needed to run C++ programs
 that use VTK. Qt files

Package: libvtk9-qt-dev
Architecture: any
Section: libdevel
Depends: libqt5opengl5-dev,
         libqt5webkit5-dev,
         libvtk9-dev (= ${binary:Version}),
         libvtk9-qt (= ${binary:Version}),
         qtbase5-dev,
         qttools5-private-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: VTK header files, containing Qt files
 The Visualization Toolkit (VTK) is an open-source software system
 for 3D computer graphics, image processing, and visualization.
 .
 This package provides the VTK header files required to compile
 C++ programs that use VTK to do 3D visualisation. Qt files

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

nojava_archs=hppa hurd-i386 kfreebsd-i386 kfreebsd-amd64
ifneq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH), $(nojava_archs)))
  export JAVA_HOME=/usr/lib/jvm/default-java
  extra_flags += -DVTK_WRAP_JAVA=ON
endif

ifneq (,$(filter $(DEB_HOST_ARCH), armel m68k mips mipsel powerpc sh4))
  export DEB_CXXFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
  export DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python3 --with javahelper

extra_flags +=  \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_C_COMPILER=mpicc \
	-DCMAKE_CXX_COMPILER=mpic++ \
	-DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed -latomic" \
	-DCMAKE_MODULE_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DHDF5_IS_PARALLEL=OFF \
	-DVTK_BUILD_DOCUMENTATION=ON \
	-DVTK_BUILD_EXAMPLES=OFF \
	-DVTK_BUILD_TESTING=OFF \
	-DVTK_EXTRA_COMPILER_WARNINGS=ON \
	-DVTK_GROUP_ENABLE_Qt:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_GUISupportQtSQL:STRING="NO" \
	-DVTK_GROUP_ENABLE_Rendering:STRING="YES" \
	-DVTK_GROUP_ENABLE_Views:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_RenderingQt:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_RenderingTk:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_utf8:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_InteractionWidgets:STRING="YES" \
	-DVTK_MODULE_ENABLE_VTK_InteractionImage:STRING="YES" \
	-DVTK_MODULE_USE_EXTERNAL_VTK_doubleconversion:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_eigen:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_expat:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_freetype:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_gl2ps:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_glew:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_hdf5:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_jpeg:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_jsoncpp:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_libproj:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_libxml2:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_lz4:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_lzma:BOOL:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_netcdf:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_ogg:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_png:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_sqlite:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_theora:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_tiff:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_utf8:BOOL=ON \
	-DVTK_MODULE_USE_EXTERNAL_VTK_zlib:BOOL=ON \
	-DVTK_PYTHON_VERSION:STRING=3 \
	-DVTK_USE_TK=ON \
	-DVTK_WRAP_PYTHON=ON \
	-DVTK_MODULE_ENABLE_VTK_RenderingContextOpenGL2=YES \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

override_dh_auto_build:
	dh_auto_build
	cd $(BUILDDIR) && make DoxygenDoc
	find $(BUILDDIR)/Utilities/Doxygen/doc/html/ -name "*.md5" | xargs rm -f

override_dh_auto_install:
	dh_auto_install -X.pyc -X.pyo
ifneq ($(JAVA_HOME),)
	# Correct headers for paraview
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/java/vtk.jar $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/java/vtk9.jar
endif
	sed -i -e "s/FATAL_ERROR/STATUS/g" $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/vtk-9.0/VTK-targets.cmake

override_dh_install:
	dh_install
	rm -rf $(CURDIR)/debian/tmp/usr/share/licenses
	find $(CURDIR)/debian/libvtk9-dev/ -name "*Qt*" -exec rm {} \; || true
	find $(CURDIR)/debian/libvtk9-dev/ -name "libvtkRenderingPythonTkWidgets.so" -exec rm {} \; || true
	find $(CURDIR)/debian/libvtk9-dev/usr/include/ -name "Q*" -exec rm {} \; || true
	find $(CURDIR)/debian/libvtk9/ -name "*Qt*" -exec rm {} \; || true
	find $(CURDIR)/debian/tmp/usr/share/doc/vtk-9.0/doxygen -name "_formulas.log" -exec rm {} \; || true
	find $(CURDIR)/debian/build/Utilities/Doxygen/doc/html -name "_formulas.log" -exec rm {} \; || true

override_dh_strip:
	dh_strip --no-automatic-dbgsym
